#!/usr/bin/perl -w

################################################################################
#
# Logviewer for BlueBox
#
# Displays logfiles humanreadable in webbrowser
#
################################################################################
# St. Wagner (c) 2004                                                          #
################################################################################
#
# Version 0.6
# 
################################################################################
use strict;
use CGI;
use CGI::Carp 'fatalsToBrowser';

use Config_param;
use CGI_Parameter;
use HTML_Darstellung;
use Array;
################################################################################
my $script = $ENV{'SCRIPT_NAME'};

################################################################################
&startDocument($script, $q, 'Logviewer');

&startDesign();


if($cgi_param{'viewtype'} eq 'Table') {
    &view_last_lines_table();
}
elsif($cgi_param{'viewtype'} eq 'List') {
    &view_last_lines_list();
}

&endDesgin();
&endDocument($script);





################################################################################
sub startDesign {
    print "<table border=\"0\" width=\"100%\">\n"
	."<tr><td width=\"$conf_page_style{'space_left'}\"></td>"
	."<td>\n";

    &print_select_function($script, %cgi_param);
    
    print "</td>\n<td width=\"$conf_page_style{'space_right'}\"></td></tr>\n";

    # Row for Pagecontent
    print"<tr><td width=\"$conf_page_style{'space_left'}\"></td><td>";
}

################################################################################
sub endDesgin {

    print "</td><td width=\"$conf_page_style{'space_right'}\"></td></tr>\n";
    print "</table>\n";
}


################################################################################
sub print_select_function {
    my ($script, %param) = @_;

    print "<form action=\"$script\" method=\"POST\">\n";
    
    print "<table border=\"0\"><tr>\n";

    print "<td>Informationlevel:</td><td>";
    if($param{'infolevel'} eq 'Basic') {
	print "<input type=\"radio\" name=\"infolevel\" value=\"Basic\" checked>";
    }
    else {
	print "<input type=\"radio\" name=\"infolevel\" value=\"Basic\">";
    }
    print " Basic\n";
    if($param{'infolevel'} eq 'Advanced') {
	print "<input type=\"radio\" name=\"infolevel\" value=\"Advanced\" checked>";
    }
    else {
	print "<input type=\"radio\" name=\"infolevel\" value=\"Advanced\">";
    }
    print " Advanced</td><td width=\"20\">&nbsp;</td>";

    
    print "<td>View Style:</td><td>";
    if($param{'viewtype'} eq 'List') {
	print "<input type=\"radio\" name=\"viewtype\" value=\"List\" checked>";
    }
    else {
	print "<input type=\"radio\" name=\"viewtype\" value=\"List\">";
    }
    print " List\n";
    if($param{'viewtype'} eq 'Table') {
	print "<input type=\"radio\" name=\"viewtype\" value=\"Table\" checked>";
    }
    else {
	print "<input type=\"radio\" name=\"viewtype\" value=\"Table\">";
    }
    print " Table</td>";

    print "<td align=\"right\"><input type=\"submit\" name=\"submit\" value=\"View\"></td></tr>\n";

    # Loglevel -----------------------------------
    print "<tr><td valign=\"top\">View Loglevel:</td>"
	."<td valign=\"top\">";

    if(&is_in_array('info', @{$param{'loglevel'}})) {
	print "<input type=\"checkbox\" name=\"loglevel\" value=\"info\" checked>";
    }
    else {
	print "<input type=\"checkbox\" name=\"loglevel\" value=\"info\">";
    }
    print "Info<br>\n";

    if(&is_in_array('message', @{$param{'loglevel'}})) {
	print "<input type=\"checkbox\" name=\"loglevel\" value=\"message\" checked>";
    }	
    else {
	print "<input type=\"checkbox\" name=\"loglevel\" value=\"message\">";
    }
    print  "Message<br>\n";

    if(&is_in_array('warn', @{$param{'loglevel'}})) {
	print "<input type=\"checkbox\" name=\"loglevel\" value=\"warn\" checked>";
    }
    else {
	print "<input type=\"checkbox\" name=\"loglevel\" value=\"warn\">";
    }
    print " Warn<br></td><td width=\"20\">&nbsp;</td>\n";

    # Details ------------------------------------
    print "<td valign=\"top\">Details:</td><td>";

    if($param{'highlight'} eq 'on') {
	print "<input type=\"checkbox\" name=\"highlight\" value=\"on\" checked>";
    }
    else {
	print "<input type=\"checkbox\" name=\"highlight\" value=\"on\">";
    }
    print " Hightlight Loglevel<br>\n";
    if($param{'linenumber'} eq 'on') {
	print "<input type=\"checkbox\" name=\"linenumber\" value=\"on\" checked>";
    }
    else {
	print "<input type=\"checkbox\" name=\"linenumber\" value=\"on\">";
    }
    print " Linenumbers<br>\n";

    if($param{'autoscroll'} eq 'on') {
	print "<input type=\"checkbox\" name=\"autoscroll\" value=\"on\" checked>";
    }
    else {
	print "<input type=\"checkbox\" name=\"autoscroll\" value=\"on\">";
    }
    print " Autoscroll\n";

    print " in interval "
	."<input type=\"input\" name=\"interval\" size=\"3\" maxlength=\"5\" value=\"$param{'interval'}\"> sec</td>\n";
    print "<td>View last "
	."<input type=\"input\" name=\"maxlines\" size=\"5\" maxlength=\"7\" value=\"$param{'maxlines'}\"> lines</td></tr>\n";

# switch of until next version !!!
    if(0) {
    if($param{'viewtype'} eq 'Table') {
	print "<tr><td>View cols:</td><td colspan=\"5\">";
	if(&is_in_array('time', @{$param{'cols'}})) {
	    print "<input type=\"checkbox\" name=\"cols\" value=\"time\" checked>";
	}
	else {
	    print "<input type=\"checkbox\" name=\"cols\" value=\"time\">";
	}
	print " Time\n";

	if(&is_in_array('loglevel', @{$param{'cols'}})) {
	    print "<input type=\"checkbox\" name=\"cols\" value=\"loglevel\" checked>";
	}
	else {
	    print "<input type=\"checkbox\" name=\"cols\" value=\"loglevel\">";
	}
	print " Loglevel\n";

	if(&is_in_array('src', @{$param{'cols'}})) {
	    print "<input type=\"checkbox\" name=\"cols\" value=\"src\" checked>";
	}
	else {
	    print "<input type=\"checkbox\" name=\"cols\" value=\"src\">";
	}
	print " Source\n";

	if(&is_in_array('dst', @{$param{'cols'}})) {
	    print "<input type=\"checkbox\" name=\"cols\" value=\"dst\" checked>";
	}
	else {
	    print "<input type=\"checkbox\" name=\"cols\" value=\"dst\">";
	}
	print " Destination";

	print "</td></tr>\n";
    }
  } 
    # switched of until next version
    if(1) {
    if($param{'infolevel'} eq 'Advanced') {
	print "<tr><td valign=\"top\">Filter:</td><td colspan=\"5\">";
	print "Source IP:<input type=\"text\" name=\"filter_src\" size=\"12\" value=\"".join(' ', @{$param{'filter_src'}})."\">";
	print " Destination IP:<input type=\"text\" name=\"filter_dst\" size=\"12\" value=\"@{$param{'filter_dst'}}\">";
	print " Protocol:<input type=\"text\" name=\"filter_proto\" size=\"6\" value=\"@{$param{'filter_proto'}}\"><br>";
	print " Sourceport:<input type=\"text\" name=\"filter_sport\" size=\"6\" value=\"@{$param{'filter_sport'}}\">";
	print " Destinationport:<input type=\"text\" name=\"filter_dport\" size=\"6\" value=\"@{$param{'filter_dport'}}\">";
	print "</td></tr>\n";
    }
    }
    print "</table>\n"
	."</form>\n";
    
 }

################################################################################
sub view_last_lines_list {
    
    my @logfile;
    my $i;

    @logfile = &get_and_limit_logfile();

    @logfile = &filter_logfile(@logfile);
    
    print "<table border=\"1\" width=\"100%\"><tr><td>";
    if($cgi_param{'infolevel'} eq 'Advanced') {
	if($cgi_param{'linenumber'} eq 'on') {
	    for($i=1; $i <= @logfile; $i++) {
		if($cgi_param{'highlight'} eq 'on') {
		    print "$i: ".&highlight_logfile_line($logfile[$i-1])."<br>\n";
		}
		else {
		    print "$i: $logfile[$i-1]<br>\n";
		}
	    }
	}
	else {
	    foreach (@logfile) {
		if($cgi_param{'highlight'} eq 'on') {
		    print &highlight_logfile_line($_)."<br>\n";
		}
		else {
		    print "$_<br>\n";
		}
	    }
	}
    }
    elsif($cgi_param{'infolevel'} eq 'Basic') {
	if($cgi_param{'linenumber'} eq 'on') {
	    for($i=1; $i <= @logfile; $i++) {
		if($cgi_param{'highlight'} eq 'on') {
		    print "$i: ".&highlight_logfile_line(&basic_filter($logfile[$i-1]))."<br>\n";
		}
		else {
		    print "$i: ".&basic_filter($logfile[$i-1])."<br>\n";
		}
	    }
	}
	else {
	    foreach (@logfile) {
		if($cgi_param{'highlight'} eq 'on') {
		    print &highlight_logfile_line(&basic_filter($_))."<br>\n";
		}
		else {
		    print &basic_filter($_)."<br>\n";
		}
	    }
	}

    }

    print "</td></tr></table>\n";


}

################################################################################
sub basic_filter {
    my ($line) = @_;

    my @entry;
    @entry = &split_logfile_entry($line);
    $entry[3] = "IN=$entry[3]";
    $entry[4] = "OUT=$entry[4]";
    $entry[5] = "SRC=$entry[5]";
    $entry[6] = "DST=$entry[6]";
    $entry[7] = "PROTO=$entry[7]";
    $entry[8] = "SPT=$entry[8]";
    $entry[9] = "DPT=$entry[9]";

    $line = join (' ', @entry);

    return ($line);
}
################################################################################
sub get_and_limit_logfile {

    my @logfile;

    my $i;

    open(LOGFILE, "<$conf_logfile{'logfile'}") 
	|| &message_error(1, "Unable to open Logfile: $conf_logfile{'loglfile'}");
    @logfile = <LOGFILE>;
    close(LOFGILE);

    # remove empty lines
    for($i=0; $i < @logfile; $i++) {
	if($logfile[$i] =~ m/^\s*$/) {
	    splice(@logfile, $i, 1);
	    $i--;
	}
    }

    if(@logfile > $cgi_param{'maxlines'} ) {
	splice(@logfile, 0, @logfile- $cgi_param{'maxlines'});
    }

    return (@logfile);
}

################################################################################
sub highlight_logfile_line {
    my ($line) = @_;

    if($line =~ m/user.warn/i) {
	$line = "<font color=\"$conf_info_color{'warn'}\">$line</font>";
    }
    elsif($line =~ m/user.info/i) {
	$line = "<font color=\"$conf_info_color{'info'}\">$line</font>";
    }

    return($line);
}

################################################################################
sub filter_logfile {
    my (@logfile) = @_;

    my $i;
    my $k;
    my $r=0;

    if($cgi_param{'infolevel'} eq 'Advanced') {
	for($i=0; $i < @logfile; $i++) {
	    if($i < 0) { $i = 0; }
	    $r = 0;
	    if(!&is_in_array('info', @{$cgi_param{'loglevel'}})) {
		if($logfile[$i] =~ m/user\.info/) {
		    splice(@logfile, $i, 1);
		    $i--;
		    next;
		}
	    }
	    if(!&is_in_array('warn', @{$cgi_param{'loglevel'}})) {
		if($logfile[$i] =~ m/user\.warn/) {
		    splice(@logfile, $i, 1);
		    $i--;
		    next;
		}
	    }
	    # source
	    if(@{$cgi_param{'filter_src'}} > 0) {
		for($k=0; $k < @{$cgi_param{'filter_src'}}; $k++) {
		    unless($logfile[$i] =~ m/SRC=${$cgi_param{'filter_src'}}[$k]/) {
			splice(@logfile, $i, 1);
			$i--;
			$r++;
		    }
		} 
	    }
	    if($r > 0) { next; }
	    # destination
	    if(@{$cgi_param{'filter_dst'}} > 0) {
		for($k=0; $k < @{$cgi_param{'filter_dst'}}; $k++) {
		    unless($logfile[$i] =~ m/DST=${$cgi_param{'filter_dst'}}[$k]/) {
			splice(@logfile, $i, 1);
			$i--;
			$r++;
		    }
		} 
	    }
	    if($r > 0) { next; }
	    # protocol
	    if(@{$cgi_param{'filter_proto'}} > 0) {
		for($k=0; $k < @{$cgi_param{'filter_proto'}}; $k++) {
		    unless($logfile[$i] =~ m/PROTO=${$cgi_param{'filter_proto'}}[$k]/) {
			splice(@logfile, $i, 1);
			$i--;
			$r++;
		    }
		} 
	    }
	    if($r > 0) { next; }
	    # Sourceport
	    if(@{$cgi_param{'filter_sport'}} > 0) {
		for($k=0; $k < @{$cgi_param{'filter_sport'}}; $k++) {
		    unless($logfile[$i] =~ m/SPT=${$cgi_param{'filter_sport'}}[$k]/) {
			splice(@logfile, $i, 1);
			$i--;
			$r++;
		    }
		} 
	    }
	    if($r > 0) { next; }
	    # Destinationport
	    if(@{$cgi_param{'filter_dport'}} > 0) {
		for($k=0; $k < @{$cgi_param{'filter_dport'}}; $k++) {
		    unless($logfile[$i] =~ m/DPT=${$cgi_param{'filter_dport'}}[$k]/) {
			splice(@logfile, $i, 1);
			$i--;
			$r++;
		    }
		} 
	    }
	    if($r > 0) { next; }
	}


    }
    elsif($cgi_param{'infolevel'} eq 'Basic') {
	for($i=0; $i < @logfile; $i++) {
	    if(!&is_in_array('info', @{$cgi_param{'loglevel'}})) {
		if($logfile[$i] =~ m/user\.info/) {
		    splice(@logfile, $i, 1);
		    $i--;
		    next;
		}
	    }
	    if(!&is_in_array('warn', @{$cgi_param{'loglevel'}})) {
		if($logfile[$i] =~ m/user\.warn/) {
		    splice(@logfile, $i, 1);
		    $i--;
		    next;
		}
	    }
	}
    
    }

    return (@logfile);
}
################################################################################
sub view_last_lines_table {
    
    my @logfile;

    @logfile = &get_and_limit_logfile();

    @logfile = &filter_logfile(@logfile);
    
    # change from 1 dim array to two dim array !
    @logfile = &split_logfile(@logfile);

    @logfile = &subst_logfile(@logfile);

    # add headline to array
    my @header = ('Time', 'Status', 'Info', 'IN', 'OUT', 'Source IP', 'Destination IP', 'Protocol', 'S-Port', 'D-Port');

    if($cgi_param{'linenumber'} eq 'on') {
	@logfile = &add_linenumber_col_array(@logfile);
	unshift(@header, 'No');
    }

    my %logfile = ('header' => \@header,
		   'array' => \@logfile);

    %logfile = &add_headline_to_array(%logfile);
    
    &print_table_array( &form_table_array (@{$logfile{'array'}}) );

}

################################################################################
sub add_linenumber_col {
    my ($content, @array) = @_;

    unshift(@array, $content);
    return(@array);
}

################################################################################
sub add_linenumber_col_array {
    my (@array) = @_;

    for(my $i=0; $i < @array; $i++) {
        my @tmp = &add_linenumber_col($i+1, @{$array[$i]});
        $array[$i] = \@tmp;
    }

    return(@array);
}
################################################################################
sub split_logfile {
    my (@logfile) = @_;

    my @log_array;
    my $line;
    
    foreach $line (@logfile) {
	my @tmp = &split_logfile_entry($line);
	push(@log_array, \@tmp);
    }    

    return (@log_array);
}
################################################################################
sub subst_logfile {
    my (@logfile) = @_;

    my @log_array;
#    my $line;
    my $line2;

    foreach $line2 (@logfile) {
	# loglevel
	if (${$line2}[1] eq 'user.warn') {
	    ${$line2}[1] = "$conf_substitution{'user.warn'}"; 
	}
	elsif (${$line2}[1] eq 'user.info') {
	    ${$line2}[1] = "$conf_substitution{'user.info'}"; 
	}
	
	# devices
	if (${$line2}[3] ne '') {
	    ${$line2}[3] = "$conf_substitution{${$line2}[3]}"; 
	}
	if (${$line2}[4] ne '') {
	    ${$line2}[4] = "$conf_substitution{${$line2}[4]}"; 
	}

	# info
	if (${$line2}[2] ne '') {
	    ${$line2}[2] = "$conf_substitution{${$line2}[2]}"; 
	}

    }    

    return (@logfile);
}


################################################################################
sub split_logfile_entry {
    my ($line) = @_;

    my @values; # = split(/ /, $line);
    my $proto;

    $line =~ m/^(\w\w\w\s+\d{1,2}\s+\d\d:\d\d:\d\d)\s+(\w+)\s+(\w+\.\w+)\s+(\w+):\s+(.*)$/;
    push(@values, $1);      # Date &time
    # push(@values, $2);    # smoothwall
    push(@values, $3);      # user.info
    # push(@values, $4);    # klogd

    # filter in second step
    $line = $5;
#    $line =~ m/^(\w+):\s+([\w:]+)\s+IN=(\w*)\s+OUT=(\w*)\s+(MAC=[0-9a-f:]+)*\s*(.*)$/;
    $line =~ m/^end:(\w+)\s+IN=(\w*)\s+OUT=(\w*)\s+(MAC=[0-9a-f:]+)*\s*(.*)$/;
    # push(@values, $1);    # fw
    push(@values, $1);      # end:ORGANGE2RED
    push(@values, $2);      # IN
    push(@values, $3);      # OUT
    # push(@values, $4);    # MAC=ff:ff:ff:ff: ..

    $line = $5;
    $line =~ m/^SRC=([\w\.]+)\s+DST=([\w\.]+)\s+LEN=(\w+)\s+TOS=(\w+)\s+PREC=(\w+)\s+TTL=(\w+)\s+ID=(\w+)\s+(.*)$/;
    push(@values, $1);
    push(@values, $2);
    # push(@values, $3);    # LEN
    # push(@values, $4);    # TOS
    # push(@values, $5);    # PREC
    # push(@values, $6);    # TTL
    # push(@values, $7);    # ID

    $line = $8;
#    print "$line<br>\n";
    $line =~ m/^(DF)*\s*PROTO=(\w+)\s+(.*)$/;
    # push(@values, $1);    # DF 
    $proto = $2;
    push(@values, $proto);    # PROTO

    $line = $3;
    # make sure that in the following cases the array has same deep
    if($proto eq 'TCP') {
	$line =~ m/^SPT=(\w+)\s+DPT=(\w+)\s+WINDOW=(\w+)\s+RES=(\w+)\s+([\w\s]+)\s+URGP=(\w+)\s+(.*)$/;
	push(@values, $1);   # SPT
	push(@values, $2);   # DPT
	# push(@values, $3);   # WINDOW
	# push(@values, $4);   # RES
	# push(@values, $5);   # RST
	# push(@values, $6);   # URGP
	# push(@values, $7);   # rest
    }
    elsif ($proto eq 'UDP') {
	$line =~ m/^SPT=(\w+)\s+DPT=(\w+)\s+LEN=(\w+)\s+(.*)$/;
	push(@values, $1);   # SPT
	push(@values, $2);   # DPT
	# push(@values, $3);   # LEN
	# push(@values, $4);   # rest
	# push(@values, '');
	# push(@values, '');
	# push(@values, '');
    }
#    elsif ($proto eq 'SCTP') {
#    elsif ($proto eq 'ICMP') {
    else {
	push(@values, $line);
    }

    # remove whitespaces befor and behind the values
    for(my $i=0; $i < @values; $i++) {
	$values[$i] =~ s/^\s*//;
	$values[$i] =~ s/\s*$//;
    }
    
    return (@values);
}


################################################################################
sub message_error {
    my ($status, @messages) = @_;

    my $line;
    foreach $line (@messages) {
	print "$line\n";
    }

    if(($status == 1) or ($status eq 'die')) {
	die();
    }

}

